X-Git-Url: https://git.madduck.net/code/vcsh.git/blobdiff_plain/b67f39a96f50708015c0986e741cfe621f255593..711b529bdfb0785adae4d10752f5c63afe4814d0:/vcsh?ds=inline

diff --git a/vcsh b/vcsh
index ee35141..fef3bc8 100755
--- a/vcsh
+++ b/vcsh
@@ -1,8 +1,19 @@
 #!/bin/sh
 
-[ -n "$VCSH_DEBUG" ]      && set -x
-[ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
-[ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
+# This program is licensed under the GNU GPL version 2 or later.
+# (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2012
+# For details, see LICENSE. To submit patches, you have to agree to
+# license your code under the GNU GPL version 2 or later.
+
+
+[ -n "$VCSH_DEBUG" ]                  && set -vx
+[ -z "$XDG_CONFIG_HOME" ]             && XDG_CONFIG_HOME="$HOME/.config"
+[ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
+[ -n "$VCSH_DEBUG" ]                  && set -vx
+[ -z "$VCSH_REPO_D" ]                 && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
+[ -z "$VCSH_HOOK_D" ]                 && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
+[ -z "$VCSH_BASE" ]                   && VCSH_BASE="$HOME"
+[ -z "$VCSH_GITIGNORE" ]              && VCSH_GITIGNORE='exact'
 
 SELF=$(basename $0)
 
@@ -13,18 +24,22 @@ help() {
          [<repo>]       Clone from an existing repository
    help                 Display this help text
    delete               Delete an existing repository
-   enter                Enter repository; spawn new $SHELL
+   enter                Enter repository; spawn new instance of \$SHELL
    init <repo>          Initialize a new repository
    list                 List all repositories
+   list-tracked         List all files tracked by vcsh
+   list-tracked-by \\
+        <repo>          List files tracked by a repository
+   rename <repo> \\
+          <newname>     Rename repository
    run <repo> \\
        <command>        Use this repository
-
-   seed-gitignore \\
-   <repo>               Seed .gitignore.d/<repo> from git ls-files
    setup                Set up repository with recommended settings
+   write-gitignore \\
+   <repo>               Write .gitignore.d/<repo> via git ls-files
 
-   <repo> <git command> Special command that allows you to run git commands
-                        directly without having to type so much ;)" >&2
+   <repo> <git command> Shortcut to run git commands directly
+   <repo>               Shortcut to enter repository" >&2
 }
 
 debug() {
@@ -48,11 +63,15 @@ info() {
 	echo "$SELF: info: $1"
 }
 
-clone () {
+clone() {
 	init
 	git remote add origin "$GIT_REMOTE"
 	git config branch.master.remote origin
 	git config branch.master.merge  refs/heads/master
+	if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
+		info "remote is empty, not merging anything"
+		exit
+	fi
 	git fetch
 	for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
 		[ -e "$object" ] &&
@@ -65,9 +84,8 @@ clone () {
 	git merge origin/master
 }
 
-delete () {
-	old_dir="$PWD"
-	cd "$HOME"
+delete() {
+	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
 	use
 	info "This operation WILL DETROY DATA!"
 	files=$(git ls-files)
@@ -76,48 +94,98 @@ delete () {
 $files
 
 AGAIN, THIS WILL DELETE YOUR DATA!
-To continue, type \"Yes, do as I say\""
+To continue, type 'Yes, do as I say'"
 	read answer
-	[ "x$answer" = "xYes, do as I say" ] || exit 16
+	[ "x$answer" = 'xYes, do as I say' ] || exit 16
 	for file in $files; do
 		rm -f $file || info "could not delete '$file', continuing with deletion"
 	done
-	rm -rf "$GIT_DIR" || info "could not delete '$GIT_DIR'"
-	cd "$old_dir"
+	rmdir "$GIT_DIR" || error "could not delete '$GIT_DIR'"
 }
 
-enter () {
+enter() {
+	hook pre-enter
 	use
 	$SHELL
+	hook post-enter
+}
+
+git_dir_exists() {
+	[ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
+}
+
+hook() {
+	for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
+		[ -x "$hook" ] || continue
+		info "executing '$hook'"
+		"$hook"
+	done
 }
 
 init() {
 	[ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
-	export GIT_WORK_TREE="$HOME"
-	mkdir -p "$GIT_WORK_TREE"
+	export GIT_WORK_TREE="$VCSH_BASE"
+	mkdir -p "$GIT_WORK_TREE" || fatal "could not create '$GIT_WORK_TREE'" 50
 	cd "$GIT_WORK_TREE" || fatal "could not enter '$GIT_WORK_TREE'" 11
-	cd "$GIT_WORK_TREE"
 	git init
 	setup
 }
 
-list () {
-	for i in "$VCSH_BASE"/*.git; do
+list() {
+	for i in "$VCSH_REPO_D"/*.git; do
 		echo $(basename "$i" .git)
 	done
 }
 
-run () {
+get_files() {
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	git ls-files
+}
+
+list_tracked() {
+	for VCSH_REPO_NAME in $(list); do
+		get_files
+	done | sort -u
+}
+
+list_tracked_by() {
+	use
+	git ls-files | sort -u
+}
+
+rename() {
+	git_dir_exists
+	[ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
+	mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
+
+}
+
+run() {
+	hook pre-run
 	use
 	$VCSH_EXTERNAL_COMMAND
+	hook post-run
+}
+
+setup() {
+	hook pre-setup
+	use
+	git config core.worktree     "$GIT_WORK_TREE"
+	git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
+	git config vcsh.vcsh         'true'
+	[ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
+	hook post-setup
 }
 
-seed_gitignore () {
+use() {
+	git_dir_exists
+	export GIT_WORK_TREE="$(git config --get core.worktree)"
+	export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+}
+
+write_gitignore() {
 	use
-	# Switching directory as this has to be executed from $HOME to be of any use.
-	# Going back into old directory at the end in case `vcsh use` is reactivated.
-	old_dir="$PWD"
-	cd "$HOME"
+	cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
 	gitignores=$(for file in $(git ls-files); do
 		while true; do
 			echo $file; new="${file%/*}"
@@ -126,76 +194,83 @@ seed_gitignore () {
 		done;
 	done | sort -u)
 	tempfile=$(mktemp) || fatal "could not create tempfile" 51
-	echo '*' > "$tempfile"
+	echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
 	for gitignore in $gitignores; do
-		echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
-		[ -d "$gitignore" ] && echo "$gitignore/*" | sed 's/^/!/'>> "$tempfile"
+		echo "$gitignore" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
+		if [ x$VCSH_GITIGNORE = x'recursive' ] && [ -d "$gitignore" ]; then
+			{ echo "$gitignore/*" | sed 's/^/!/' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
+		fi
 	done
-	diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
-		rm -f "$tempfile" &&
+	if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
+		rm -f "$tempfile" || error "could not delete '$tempfile'"
 		exit
-	if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
-		info "'$HOME/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'"
-		mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
-			fatal "could not move '$HOME/.gitignore.d/$VCSH_REPO_NAME' to '$HOME/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
 	fi
-	mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
-		fatal "could not move '$tempfile' to '$HOME/.gitignore.d/$VCSH_REPO_NAME'" 53
-	cd "$old_dir"
-}
-
-setup() {
-	use
-	git config core.worktree     "$GIT_WORK_TREE"
-	git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
-	git config vcsh.vcsh         'true'
-	touch   "$HOME/.gitignore.d/$VCSH_REPO_NAME"
-	git add "$HOME/.gitignore.d/$VCSH_REPO_NAME"
-}
-
-use() {
-	if [ ! -d "$GIT_DIR" ]; then
-		fatal "no repository found for '$VCSH_REPO_NAME'" 12
+	if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
+		info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
+		mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
+			fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
 	fi
-	export GIT_WORK_TREE="$(git config --get core.worktree)"
-	export VCSH_DIRECTORY="$VCSH_REPO_NAME"
+	mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
+		fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
 }
 
+if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ]; then
+	fatal "'\$VCSH_GITIGNORE' must be either 'exact' or 'recursive'" 1
+fi
+
 if [ "$1" = 'clone' ]; then
 	[ -z $2 ] && fatal "$1: please specify a remote" 1
 	export VCSH_COMMAND="$1"
 	GIT_REMOTE="$2"
 	[ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
 	export VCSH_REPO_NAME
-	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-elif [ "$1" = 'delete' ] ||
-     [ "$1" = 'enter' ] ||
-     [ "$1" = 'init' ] ||
-     [ "$1" = 'run' ] ||
-     [ "$1" = 'seed-gitignore' ] ||
-     [ "$1" = 'setup' ]; then
-	[ -z $2 ] && fatal "$1: please specify repository to work on" 1
-	[ "$1" = 'run' -a -z "$3" ] && fatal "$1: please specify a command" 1
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+elif [ "$1" = 'delete' ]           ||
+     [ "$1" = 'enter' ]            ||
+     [ "$1" = 'init' ]             ||
+     [ "$1" = 'list-tracked-by' ]  ||
+     [ "$1" = 'rename' ]           ||
+     [ "$1" = 'run' ]              ||
+     [ "$1" = 'setup' ]            ||
+     [ "$1" = 'write-gitignore' ]; then
+	[ -z $2 ]                      && fatal "$1: please specify repository to work on" 1
+	[ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
+	[ "$1" = 'run' -a -z "$3" ]    && fatal "$1: please specify a command" 1
 	export VCSH_COMMAND="$1"
 	export VCSH_REPO_NAME="$2"
-	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-	[ "$1" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$@"
-	[ "$1" = 'seed-gitignore' ] && export VCSH_COMMAND=seed_gitignore
-elif [ "$1" = 'list' ]; then
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	[ "$VCSH_COMMAND" = 'rename' ]         && export GIT_DIR_NEW="$VCSH_REPO_D/$3.git"
+	[ "$VCSH_COMMAND" = 'run' ] && shift 2 && export VCSH_EXTERNAL_COMMAND="$*"
+	[ "$VCSH_COMMAND" = 'write-gitignore' ]
+elif [ "$1" = 'list' ] ||
+     [ "$1" = 'list-tracked' ]; then
 	export VCSH_COMMAND="$1"
-elif [ -n "$1" ]; then
-	export VCSH_COMMAND=run
+elif [ -n "$2" ]; then
+	export VCSH_COMMAND='run'
 	export VCSH_REPO_NAME="$1"
-	export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
 	[ -d $GIT_DIR ] || { help; exit 1; }
 	shift 1
 	export VCSH_EXTERNAL_COMMAND="git $*"
+elif [ -n "$1" ]; then
+	export VCSH_COMMAND='enter'
+	export VCSH_REPO_NAME="$1"
+	export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
+	[ -d $GIT_DIR ] || { help; exit 1; }
 else
 	# $1 is empty, or 'help'
 	help && exit
 fi
 
-for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
+# Did we receive a directory instead of a name?
+# Mangle the input to fit normal operation.
+if echo $VCSH_REPO_NAME | grep -q '/'; then
+	export GIT_DIR=$VCSH_REPO_NAME
+	export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
+fi
+
+
+for check_directory in "$VCSH_REPO_D" "$VCSH_BASE/.gitignore.d"
 do
 	if [ ! -d "$check_directory" ]; then
 		if [ -e "$check_directory" ]; then
@@ -208,5 +283,6 @@ do
 done
 
 verbose "$VCSH_COMMAND begin"
+export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
 $VCSH_COMMAND
 verbose "$VCSH_COMMAND end, exiting"